from tkinter import *
from tkinter.filedialog import *
import os

class portaeppendorf(Frame):

    def __init__(self, parent=None, numrow=10, numcol=10):
        Frame.__init__(self, parent)
        self.numrow = numrow
        self.numcol = numcol
        self.makewidgets(numrow, numcol)

    def makewidgets(self, numrow, numcol):
        self.rows = []
        for i in range(numrow):
            cols = []
            for j in range(numcol):
                e = Entry(self, relief=RIDGE)
                e.grid(row=i+1, column=j, sticky=NSEW)
                e.insert(END, '%d.%d' % (i, j))
                cols.append(e)
            self.rows.append(cols)

        Button(self, text='Load', command=self.onload).grid(row=11, column=0)
        Button(self, text='Clear', command=self.onclear).grid(row=11, column=2)
        Button(self, text='Save', command=self.onsave).grid(row=11, column=1)
        Button(self, text='Quit', command=root.destroy).grid(row=11, column=9)

    def onclear(self):
        for row in self.rows:
            for col in row:
                col.delete('0', END)
                col.insert(END, '0.0')

    def onload(self):
        file = askopenfilename()
        if file:
            for r in self.rows:
                for c in r:
                    c.grid_forget()
                filelines = open(file, 'r').readlines()
                self.numrow = len(filelines)
                self.numcol = len(filelines[0].split())
                self.makewidgets(self.numrow, self.numcol)
                row = 0
                for line in filelines:
                    fields = line.split()
                    for col in range(self.numcol):
                        self.rows[row][col].delete('0', END)
                        self.rows[row][col].insert(END, fields[col])
                    row = row+1
    def onsave(self):
        save = asksaveasfilename()
        if save:
            check = os.listdir()
            if save in check:
                os.remove(save)
                savefile = open(save, 'w')
                for i in self.rows:
                    savefile.write(' '.join(str(n.get()) for n in i)+'\n')
                savefile.close()
            else:
                savefile = open(save, 'w')
                for i in self.rows:
                    savefile.write(' '.join(str(n.get()) for n in i)+'\n')
                savefile.close()
        

if __name__=='__main__':
    root = Tk()
    root.title('Eppendorf')
    portaeppendorf(root).pack()
    mainloop()
    
